package dev.shadowsoffire.apotheosis.advancements;

package .tmp;

import com.google.common.collect.Maps;
import com.google.gson.JsonObject;
import dev.shadowsoffire.apotheosis.advancements.ModifierTrigger;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerModifier;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStats;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import java.util.Map;
import net.minecraft.advancements.CriterionTrigger;
import net.minecraft.advancements.CriterionTriggerInstance;
import net.minecraft.advancements.critereon.DeserializationContext;
import net.minecraft.advancements.critereon.MinMaxBounds;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.PlayerAdvancements;
import net.minecraft.server.level.ServerPlayer;

public class ModifierTrigger implements CriterionTrigger<ModifierTrigger.Instance> {
  private static final ResourceLocation ID = new ResourceLocation("apotheosis", "spawner_modifier");
  
  private final Map<PlayerAdvancements, Listeners> listeners = Maps.newHashMap();
  
  public ResourceLocation m_7295_() {
    return ID;
  }
  
  public void m_6467_(PlayerAdvancements playerAdvancementsIn, CriterionTrigger.Listener<Instance> listener) {
    Listeners ModifierTrigger$listeners = this.listeners.get(playerAdvancementsIn);
    if (ModifierTrigger$listeners == null) {
      ModifierTrigger$listeners = new Listeners(playerAdvancementsIn);
      this.listeners.put(playerAdvancementsIn, ModifierTrigger$listeners);
    } 
    ModifierTrigger$listeners.add(listener);
  }
  
  public void m_6468_(PlayerAdvancements playerAdvancementsIn, CriterionTrigger.Listener<Instance> listener) {
    Listeners ModifierTrigger$listeners = this.listeners.get(playerAdvancementsIn);
    if (ModifierTrigger$listeners != null) {
      ModifierTrigger$listeners.remove(listener);
      if (ModifierTrigger$listeners.isEmpty())
        this.listeners.remove(playerAdvancementsIn); 
    } 
  }
  
  public void m_5656_(PlayerAdvancements playerAdvancementsIn) {
    this.listeners.remove(playerAdvancementsIn);
  }
  
  public Instance createInstance(JsonObject json, DeserializationContext conditionsParser) {
    MinMaxBounds.Ints minDelay = MinMaxBounds.Ints.m_55373_(json.get(SpawnerStats.MIN_DELAY.getId()));
    MinMaxBounds.Ints maxDelay = MinMaxBounds.Ints.m_55373_(json.get(SpawnerStats.MAX_DELAY.getId()));
    MinMaxBounds.Ints spawnCount = MinMaxBounds.Ints.m_55373_(json.get(SpawnerStats.SPAWN_COUNT.getId()));
    MinMaxBounds.Ints nearbyEnts = MinMaxBounds.Ints.m_55373_(json.get(SpawnerStats.MAX_NEARBY_ENTITIES.getId()));
    MinMaxBounds.Ints playerRange = MinMaxBounds.Ints.m_55373_(json.get(SpawnerStats.REQ_PLAYER_RANGE.getId()));
    MinMaxBounds.Ints spawnRange = MinMaxBounds.Ints.m_55373_(json.get(SpawnerStats.SPAWN_RANGE.getId()));
    Boolean ignorePlayers = json.has(SpawnerStats.IGNORE_PLAYERS.getId()) ? Boolean.valueOf(json.get(SpawnerStats.IGNORE_PLAYERS.getId()).getAsBoolean()) : null;
    Boolean ignoreConditions = json.has(SpawnerStats.IGNORE_CONDITIONS.getId()) ? Boolean.valueOf(json.get(SpawnerStats.IGNORE_CONDITIONS.getId()).getAsBoolean()) : null;
    Boolean redstone = json.has(SpawnerStats.REDSTONE_CONTROL.getId()) ? Boolean.valueOf(json.get(SpawnerStats.REDSTONE_CONTROL.getId()).getAsBoolean()) : null;
    Boolean ignoreLight = json.has(SpawnerStats.IGNORE_LIGHT.getId()) ? Boolean.valueOf(json.get(SpawnerStats.IGNORE_LIGHT.getId()).getAsBoolean()) : null;
    Boolean noAI = json.has(SpawnerStats.NO_AI.getId()) ? Boolean.valueOf(json.get(SpawnerStats.NO_AI.getId()).getAsBoolean()) : null;
    return new Instance(minDelay, maxDelay, spawnCount, nearbyEnts, playerRange, spawnRange, ignorePlayers, ignoreConditions, redstone, ignoreLight, noAI);
  }
  
  public void trigger(ServerPlayer player, ApothSpawnerTile tile, SpawnerModifier modif) {
    Listeners ModifierTrigger$listeners = this.listeners.get(player.m_8960_());
    if (ModifierTrigger$listeners != null)
      ModifierTrigger$listeners.trigger(tile, modif); 
  }
}
